{This component is designed for Delphi Version 1.x. It subclasses
THeader, adding one new event, OnSectionClick. This event returns
the section number that was clicked, starting at zero to Sections-1.
Freeware, Source code included. Comments/suggestions appreciated.
Also, if you have any problems with it, please feel free to contact
me. -Enjoy.

Ted Kahn tedkahn@interramp.com   CIS 70353,2603}

unit Headclk;

interface

uses
  Classes, Controls, ExtCtrls;

type
	TSectionClickEvent = procedure (Sender: TObject; ASection: integer) of object;
  THeaderClick = class(THeader)
  private
    { Private declarations }
    FOnSectionClick: TSectionClickEvent;
  protected
    { Protected declarations }
    procedure SectionClick; dynamic;
		procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  	procedure Sizing( ASection, AWidth: Integer); override;
  public
    { Public declarations }
 published
    { Published declarations }
    property OnSectionClick: TSectionClickEvent read FOnSectionClick write FOnSectionClick;
end;

procedure Register;

implementation
var
	InResize: boolean;
  ClickedSection: integer;

procedure THeaderClick.SectionClick;
begin
	if Assigned(FOnSectionClick) then FOnSectionClick(Self, ClickedSection);
end;

procedure THeaderClick.Sizing;
begin
	inherited Sized(ASection, AWidth);
	InResize := true;
end;

procedure THeaderClick.MouseUp;
var
	i,j: integer;
begin
	inherited MouseUp(Button,Shift, X, Y);
	if not InResize then begin
    j := 0;
    for i := 0 to Sections.Count-1 do begin
      j := j + SectionWidth[i];
      if j >= x then begin
        ClickedSection := i;
        SectionClick;
        break;
      end;
    end;
  end;
  InResize := false;
end;

procedure Register;
begin
  RegisterComponents('Ted', [THeaderClick]);
end;

end.
